<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douco.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议：http://www.douco.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'job';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 定义招聘属性功能
$attribute_field = array('category', 'type', 'place');
foreach ($attribute_field as $field) {
    $_REQUEST[$field] = $check->is_search_keyword($_REQUEST[$field]) ? $_REQUEST[$field] : '';
    if ($_REQUEST[$field]) $request_where[$field] = $_REQUEST[$field]; // 筛选条件中要排除值为空的属性
    $attribute[$field] = $dou->get_no_repeat_value('job', $field, $_REQUEST[$field]);
}

// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('attribute', $attribute);

/**
 * +----------------------------------------------------------
 * 招聘列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['job']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['job_add'],
            'href' => 'job.php?rec=add' 
    ));
    
    // 定义筛选条件
    foreach ((array)$request_where as $key=>$attribute) {
        $where .= " AND `$key` = '$attribute'";
        $get = $get . "&$key=$attribute";
    }
    
    // 把第一个AND替换成WHERE
    $where = $dou->where($where);
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('job') . $where . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 20, $page, 'job.php', $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $add_time = date("Y-m-d", $row['add_time']);
        
        $job_list[] = array (
                "id" => $row['id'],
                "position" => $row['position'],
                "category" => $row['category'],
                "type" => $row['type'],
                "place" => $row['place'],
                "number" => $row['number'],
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('job_list', $job_list);
    
    $smarty->display('job.htm');
} 

/**
 * +----------------------------------------------------------
 * 招聘添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['job_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['job'],
            'href' => 'job.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    
    $smarty->display('job.htm');
} 

elseif ($rec == 'insert') {
    // 判断是否为空
    $field = array('position', 'responsibility', 'requirement');
    foreach ($field as $value) {
        if (!$_POST[$value])
            $dou->dou_msg($_LANG[$value] . $_LANG['is_empty']);
    }
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    // 格式化数据
    $add_time = time();
        
    $sql = "INSERT INTO " . $dou->table('job') . " (id, position, category, type, place, number, responsibility, requirement, add_time)" . " VALUES (NULL, '$_POST[position]', '$_POST[category]', '$_POST[type]', '$_POST[place]', '$_POST[number]', '$_POST[responsibility]', '$_POST[requirement]', '$add_time')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['job_add'] . ': ' . $_POST['position']);
    $dou->dou_msg($_LANG['job_add'] . $_LANG['succes'], 'job.php');
} 

/**
 * +----------------------------------------------------------
 * 招聘编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['job_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['job'],
            'href' => 'job.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $job = $dou->get_row('job', '*', "id = '$id'");
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('job', $job);
    
    $smarty->display('job.htm');
} 

elseif ($rec == 'update') {
    // 判断是否为空
    $field = array('position', 'responsibility', 'requirement');
    foreach ($field as $value) {
        if (!$_POST[$value])
            $dou->dou_msg($_LANG[$value] . $_LANG['is_empty']);
    }
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "UPDATE " . $dou->table('job') . " SET position = '$_POST[position]', category = '$_POST[category]', type = '$_POST[type]' ,place = '$_POST[place]', number = '$_POST[number]', responsibility = '$_POST[responsibility]', requirement = '$_POST[requirement]' WHERE id = '$_POST[id]'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['job_edit'] . ': ' . $_POST['position']);
    $dou->dou_msg($_LANG['job_edit'] . $_LANG['succes'], 'job.php');
} 

/**
 * +----------------------------------------------------------
 * 招聘删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'job.php');
    $position = $dou->get_one("SELECT position FROM " . $dou->table('job') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm']) ? $_POST['confirm'] : '') {
        $dou->create_admin_log($_LANG['job_del'] . ': ' . $position);
        $dou->delete('job', "id = '$id'", 'job.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $position, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'job.php', '', '30', "job.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            // 批量招聘删除
            $dou->del_all('job', $_POST['checkbox'], 'id');
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['job_select_empty']);
    }
}

?>