<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douco.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议：http://www.douco.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'job';
require (dirname(__FILE__) . '/include/init.php');

// 定义招聘属性功能
$attribute_field = array('category', 'type', 'place');
foreach ($attribute_field as $value) {
    $_REQUEST[$value] = $check->is_search_keyword($_REQUEST[$value]) ? $_REQUEST[$value] : '';
    // 如果没有赋值则将属性设置为“不限”
    $_REQUEST[$value] = $_REQUEST[$value] ? $_REQUEST[$value] : $_LANG['job_attribute_all'];
    // 筛选条件中要排除值为“不限”的属性
    if ($_REQUEST[$value] && $_REQUEST[$value] != $_LANG['job_attribute_all']) $request_where[$value] = $_REQUEST[$value];
    // 生成筛选参数列表
    $attribute[$value] = job_attribute($value);
}

// 定义筛选条件
$i = 0;
foreach ($request_where as $key=>$value) {
    $and = (++$i != 1) ? ' AND' : '';
    $where .= $and . " `$key` = '$value'";
    $get .= "&$key=$value";
}
$where = $where ? 'WHERE' . $where : '';

/* 获取招聘列表 */
$sql = "SELECT * FROM " . $dou->table('job') . $where . " ORDER BY id DESC";

// 获取分页信息
$page = $check->is_number($_REQUEST['page']) ? trim($_REQUEST['page']) : 1;
$limit = $dou->pager($sql, ($_DISPLAY['job'] ? $_DISPLAY['job'] : 5), $page);

/* 获取产品列表 */
$sql = $sql . $limit; // 加入分页条件的SQL语句
$query = $dou->query($sql);
while ($row = $dou->fetch_array($query)) {
    $add_time = date("Y-m-d", $row['add_time']);
    
    $job_list[] = array (
            "id" => $row['id'],
            "position" => $row['position'],
            "category" => $row['category'],
            "type" => $row['type'],
            "place" => $row['place'],
            "number" => $row['number'],
            "responsibility" => $row['responsibility'],
            "requirement" => $row['requirement'],
            "add_time" => $add_time 
    );
}

// 数据封装
$data['sql'] = $sql;
$data['title'] = $_LANG['job'];
$data['attribute'] = $attribute;
$data['job_list'] = $job_list;

echo json_encode($data);

/**
 * +----------------------------------------------------------
 * 获取属性
 * +----------------------------------------------------------
 */
function job_attribute($field) {
    $sql = "SELECT $field FROM " . $GLOBALS['dou']->table('job') . " WHERE $field != ''  ORDER BY id ASC";
    $query = $GLOBALS['dou']->query($sql);
 
    if (mysqli_num_rows($query) > 0) {
        $job_attribute_option[] = $GLOBALS['_LANG']['job_attribute_all'];
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            $job_attribute_option[] = $row[$field];
        }
        $job_attribute_option = array_unique($job_attribute_option); // 过滤掉重复值

        foreach ($job_attribute_option as $value) {
            $job_attribute[] = $value;
        }

        return $job_attribute;
    }
}

/**
 * +----------------------------------------------------------
 * 生成参数尾巴
 * +----------------------------------------------------------
 */
function job_url($field, $value) {
    $i = 0;
    foreach ($GLOBALS['attribute_field'] as $v) { // 遍历所有参数
        $symbol = (++$i == 1) ? '?' : '&';
        $req = $v == $field ? $value : $GLOBALS['_REQUEST'][$v]; // 改变当前参数值，其它参数值自动获取url传递过来的值
        if ($req)
            $url .= $symbol . "$v=" . $req;
    }

    return $url;
}

?>